
package de.ivu.elect.presentation.wahlrechtspruefung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.wahlrechtspruefung.boundary.PruefkriteriumBoundaryCreate;
import de.ivu.elect.business.wahlrechtspruefung.entity.Pruefkriterium;
import de.ivu.elect.business.wahlrechtspruefung.entity.PruefkriteriumMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractPruefkriteriumCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractPruefkriteriumCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.PRUEFKRITERIUM_CREATE)
public abstract class AbstractPruefkriteriumCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Pruefkriterium> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "pruefkriteriumCreateView";

  public static final String VIEW_ID = "/wahlrechtspruefung/pruefkriterium-create.xhtml";

  public static final String PARENT_VIEW_ID = "/wahlrechtspruefung/pruefkriterium-search.xhtml";

  @Inject
  protected transient PruefkriteriumBoundaryCreate create;

  protected Pruefkriterium entity;

  @Inject
  protected transient PruefkriteriumMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Pruefkriterium());
  }

  

  public Pruefkriterium getEntity() {
    return entity;
  }

  protected void setEntity(Pruefkriterium entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.PRUEFKRITERIUM_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Pruefkriterium entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Pruefkriterium entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.PRUEFKRITERIUM_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
